VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsMp3Player"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

' ----==== Const ====----
Private Const S_OK As Long = &H0&
Private Const API_TRUE As Long = &H1
Private Const API_FALSE As Long = &H0
Private Const GdiPlusVersion As Long = &H1&

Private Const CLSID_FilterGraph As String = "{E436EBB3-524F-11CE-9F53-0020AF0BA770}"

Private Const IID_IBasicAudio As String = "{56A868B3-0AD4-11CE-B03A-0020AF0BA770}"
Private Const IID_IGraphBuilder As String = "{56A868A9-0AD4-11CE-B03A-0020AF0BA770}"
Private Const IID_IMediaControl As String = "{56A868B1-0AD4-11CE-B03A-0020AF0BA770}"
Private Const IID_IMediaSeeking As String = "{36B73880-C2C8-11CF-8B46-00805F6CEF60}"
Private Const IID_IMediaPosition As String = "{56A868B2-0AD4-11CE-B03A-0020AF0BA770}"
Private Const IID_IPropertyStore As String = "{886D8EEB-8CF2-4446-8D02-CDBA1DBDCF99}"
Private Const IID_IPicture As String = "{7BF80980-BF32-101A-8BBB-00AA00300CAB}"

Private Const TIME_FORMAT_MEDIA_TIME As String = "{7B785574-8C82-11CF-BC0C-00AA00AC74F6}"

' ----==== Enums ====----
Private Enum vtb_Interfaces
    QueryInterface = 0          'IUnknown
    
    GetValue = 5                'IPropertyStore
    
    Run_Play = 7                'IMediaControl
    Pause_Play = 8              'IMediaControl
    Stop_Play = 9               'IMediaControl
    GetPlayState = 10           'IMediaControl
    
    put_Volume = 7              'IBasicAudio
    get_Volume = 8              'IBasicAudio
    put_Balance = 9             'IBasicAudio
    get_Balance = 10            'IBasicAudio
    
    get_Duration = 7            'IMediaPosition
    put_CurrentPosition = 8     'IMediaPosition
    get_CurrentPosition = 9     'IMediaPosition
    get_StopTime = 10           'IMediaPosition
    put_StopTime = 11           'IMediaPosition
    
    SetTimeFormat = 9           'IMediaSeeking
    
    RenderFile = 13             'IGraphBuilder
End Enum

Private Enum VARENUM
    VT_EMPTY = 0  '&H0
    VT_NULL = 1  '&H1
    VT_I2 = 2  '&H2
    VT_I4 = 3  '&H3
    VT_R4 = 4  '&H4
    VT_R8 = 5  '&H5
    VT_CY = 6  '&H6
    VT_DATE = 7  '&H7
    VT_BSTR = 8  '&H8
    VT_DISPATCH = 9  '&H9
    VT_ERROR = 10  '&HA
    VT_BOOL = 11  '&HB
    VT_VARIANT = 12  '&HC
    VT_UNKNOWN = 13  '&HD
    VT_DECIMAL = 14  '&HE
    VT_I1 = 16  '&H10
    VT_UI1 = 17  '&H11
    VT_UI2 = 18  '&H12
    VT_UI4 = 19  '&H13
    VT_I8 = 20  '&H14
    VT_UI8 = 21  '&H15
    VT_INT = 22  '&H16
    VT_UINT = 23  '&H17
    VT_VOID = 24  '&H18
    VT_HRESULT = 25  '&H19
    VT_PTR = 26  '&H1A
    VT_SAFEARRAY = 27  '&H1B
    VT_CARRAY = 28  '&H1C
    VT_USERDEFINED = 29  '&H1D
    VT_LPSTR = 30  '&H1E
    VT_LPWSTR = 31  '&H1F
    VT_RECORD = 36  '&H24
    VT_FILETIME = 64  '&H40
    VT_BLOB = 65  '&H41
    VT_STREAM = 66  '&H42
    VT_STORAGE = 67  '&H43
    VT_STREAMED_OBJECT = 68  '&H44
    VT_STORED_OBJECT = 69  '&H45
    VT_BLOB_OBJECT = 70  '&H46
    VT_CF = 71  '&H47
    VT_CLSID = 72  '&H48
    VT_VECTOR = 4096  '&H1000
    VT_ARRAY = 8192  '&H2000
    VT_BYREF = 16384  '&H4000
    VT_RESERVED = 32768  '&H8000
    VT_ILLEGAL = 65535 '&HFFFF
    VT_ILLEGALMASKED = 4095 '&HFFF
    VT_TYPEMASK = 4095 '&HFFF
End Enum

Private Enum Status
    OK = 0
    GenericError = 1
    InvalidParameter = 2
    OutOfMemory = 3
    ObjectBusy = 4
    InsufficientBuffer = 5
    NotImplemented = 6
    Win32Error = 7
    WrongState = 8
    Aborted = 9
    FileNotFound = 10
    ValueOverflow = 11
    AccessDenied = 12
    UnknownImageFormat = 13
    FontFamilyNotFound = 14
    FontStyleNotFound = 15
    NotTrueTypeFont = 16
    UnsupportedGdiplusVersion = 17
    GdiplusNotInitialized = 18
    PropertyNotFound = 19
    PropertyNotSupported = 20
    ProfileNotFound = 21
End Enum

Private Enum GETPROPERTYSTOREFLAGS
    GPS_DEFAULT = &H0
    GPS_HANDLERPROPERTIESONLY = &H1
    GPS_READWRITE = &H2
    GPS_TEMPORARY = &H4
    GPS_FASTPROPERTIESONLY = &H8
    GPS_OPENSLOWITEM = &H10
    GPS_DELAYCREATION = &H20
    GPS_BESTEFFORT = &H40
    GPS_NO_OPLOCK = &H80
    GPS_MASK_VALID = &HFF
End Enum

Private Enum PSTIME_FLAGS
    PSTF_UTC = 0
    PSTF_LOCAL = 1
End Enum

' ----==== Type ====----
Private Type GUID
    data1 As Long
    data2 As Integer
    data3 As Integer
    data4(0 To 7) As Byte
End Type

Private Type FILETIME
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type

Private Type SYSTEMTIME
    wYear As Integer
    wMonth As Integer
    wDayOfWeek As Integer
    wDay As Integer
    wHour As Integer
    wMinute As Integer
    wSecond As Integer
    wMilliSeconds As Integer
End Type

Private Type PROPERTYKEY
    fmtid As GUID
    pid As Long
End Type

Private Type PROPVARIANT
    vt As Integer
    wReserved1 As Integer
    wReserved2 As Integer
    wReserved3 As Integer
    vData As Long
    vDummy As Long
End Type

Private Type GDIPlusStartupInput
    GdiPlusVersion As Long
    DebugEventCallback As Long
    SuppressBackgroundThread As Long
    SuppressExternalCodecs As Long
End Type

Private Type GdiplusStartupOutput
    NotificationHook As Long
    NotificationUnhook As Long
End Type

Private Type PICTDESC
    cbSizeOfStruct As Long
    PicType As Long
    hgdiObj As Long
    hPalOrXYExt As Long
End Type

Private Type MP3Info
    Cover As StdPicture
    Interpret As String
    Songtitel As String
    AlbumArtist As String
    AlbumTitle As String
    TrackNumber As String
    Genre As String
    Duration As String
    SampleRate As String
    EncodingBitrate As String
    SampleSize As String
    ChannelCount As String
    IsVariableBitRate As String
End Type

' ----==== Ole32.dll Deklarationen ====----
Private Declare Function CLSIDFromString Lib "Ole32.dll" ( _
                         ByVal pstring As Long, _
                         ByRef pCLSID As GUID) As Long

' ----==== Oleaut32.dll Deklarationen ====----
Private Declare Function OleCreatePictureIndirect Lib "Oleaut32.dll" ( _
                         ByRef lpPictDesc As PICTDESC, _
                         ByRef riid As GUID, _
                         ByVal fOwn As Boolean, _
                         ByRef lplpvObj As Object) As Long

' ----==== Kernel32.dll Deklarationen ====----
Private Declare Function FileTimeToSystemTime Lib "kernel32.dll" ( _
                         ByRef lpFileTime As FILETIME, _
                         ByRef lpSystemTime As SYSTEMTIME) As Long

' ----==== Shlwapi.dll Deklarationen ====----
Private Declare Function PathFileExistsW Lib "Shlwapi.dll" ( _
                         ByVal pszFile As Long) As Long

' ----==== Shell32.dll Deklarationen ====----
Private Declare Function SHGetPropertyStoreFromParsingName Lib "shell32.dll" ( _
                         ByVal pszPath As Long, _
                         ByVal pbc As Long, _
                         ByVal flags As GETPROPERTYSTOREFLAGS, _
                         ByRef riid As GUID, _
                         ByRef ppv As Long) As Long

' ----==== Propsys.dll Deklarationen ====----
Private Declare Function PSGetPropertyKeyFromName Lib "Propsys.dll" ( _
                         ByVal pszName As Long, _
                         ByRef propkey As PROPERTYKEY) As Long

Private Declare Function PropVariantChangeType Lib "Propsys.dll" ( _
                         ByVal ppropvarDest As Long, _
                         ByVal propvarSrc As Long, _
                         ByVal flags As Long, _
                         ByVal vt As VARENUM) As Long

Private Declare Function PropVariantToFileTime Lib "Propsys.dll" ( _
                         ByRef ppropvar As PROPVARIANT, _
                         ByVal pstfOut As PSTIME_FLAGS, _
                         ByRef pftOut As FILETIME) As Long

' ----==== Gdiplus.dll Deklarationen ====----
Private Declare Function GdiplusShutdown Lib "Gdiplus.dll" ( _
                         ByVal token As Long) As Status

Private Declare Function GdiplusStartup Lib "Gdiplus.dll" ( _
                         ByRef token As Long, _
                         ByRef lpInput As GDIPlusStartupInput, _
                         ByRef lpOutput As GdiplusStartupOutput) As Status

Private Declare Function GdipDisposeImage Lib "Gdiplus.dll" ( _
                         ByVal image As Long) As Status

Private Declare Function GdipCreateBitmapFromStream Lib "Gdiplus.dll" ( _
                         ByVal mStream As Long, _
                         ByRef mBitmap As Long) As Status
                         
Private Declare Function GdipCreateHBITMAPFromBitmap Lib "Gdiplus.dll" ( _
                         ByVal Bitmap As Long, _
                         ByRef hbmReturn As Long, _
                         ByVal Background As Long) As Status
                         

' ----==== Variablen ====----
Private m_Init As Boolean
Private m_Rendered As Boolean
Private m_Info As Boolean
Private m_Duration As Double
Private m_Filename As String
Private m_pIBasicAudio As Long
Private m_pIMediaEventEx As Long
Private m_pIMediaControl As Long
Private m_pIMediaSeeking As Long
Private m_pIGraphBuilder As Long
Private m_pIMediaPosition As Long
Private m_tMP3Info As MP3Info

Public Property Let Filename(ByVal sFileName As String)

    If Len(sFileName) > 0 Then

        If PathFileExistsW(StrPtr(sFileName)) = API_TRUE Then

            If m_Init = True Then

                Call Reset
                Call Initialize

                m_Filename = sFileName
                
                m_Info = GetMediaInfo(sFileName)

                If m_Init = True Then

                    If Invoke(m_pIGraphBuilder, RenderFile, StrPtr(m_Filename), 0&) = S_OK Then
                    
                        If Invoke(m_pIMediaSeeking, SetTimeFormat, VarPtr(Str2Guid(TIME_FORMAT_MEDIA_TIME))) = S_OK Then
                        
                            If Invoke(m_pIMediaPosition, get_Duration, VarPtr(m_Duration)) = S_OK Then

                                m_Rendered = True

                            End If
                        
                        End If

                    End If

                End If

            End If

        Else
            
            MsgBox "File missing.", vbOKOnly Or vbInformation, "File missing."
            
        End If
        
    Else
    
        MsgBox "File missing.", vbOKOnly Or vbInformation, "File missing."

    End If

    If m_Rendered = False Then
    
        MsgBox "File cant rendered.", vbOKOnly Or vbInformation, "Render File."
        
    End If

End Property

Public Property Get Filename() As String
    
    Filename = m_Filename

End Property

Public Property Get IsInit() As Boolean
    
    IsInit = m_Init

End Property

Public Property Get IsRendered() As Boolean
    
    IsRendered = m_Rendered

End Property

Public Property Get IsInfo() As Boolean
    
    IsInfo = m_Info

End Property

Public Function StartPlay() As Boolean

    Dim bRet As Boolean
    
    bRet = False
    
    If m_Init = True Then
        
        If Invoke(m_pIMediaControl, Run_Play) = S_OK Then
        
            bRet = True
            
        End If
        
    End If

    StartPlay = bRet
    
End Function

Public Function PausePlay() As Boolean

    Dim bRet As Boolean
    
    bRet = False
    
    If m_Init = True Then
        
        If Invoke(m_pIMediaControl, Pause_Play) = S_OK Then
        
            bRet = True
            
        End If
        
    End If

    PausePlay = bRet
    
End Function

Public Function StopPlay() As Boolean

    Dim bRet As Boolean
    
    bRet = False
    
    If m_Init = True Then
        
        If Invoke(m_pIMediaControl, Stop_Play) = S_OK Then
        
            bRet = True
            
        End If
        
    End If

    StopPlay = bRet
    
End Function

Public Function GetState() As FILTER_STATE
    
    Dim tFS As FILTER_STATE
    
    If m_Init = True Then

        If Invoke(m_pIMediaControl, GetPlayState, 0&, VarPtr(tFS)) <> S_OK Then
                
            tFS = State_Fail

        End If

    End If

    GetState = tFS

End Function

Public Property Get GetDuration() As Double
    
    GetDuration = m_Duration

End Property

Public Function GetPosition() As Double

    Dim dRet As Double
    Dim dCurrPos As Double

    If m_Init = True Then

        If Invoke(m_pIMediaPosition, get_CurrentPosition, VarPtr(dCurrPos)) = S_OK Then

            dRet = dCurrPos

        End If
    
    End If

    GetPosition = dRet

End Function

Public Function SetPosition(ByVal dPos As Double) As Boolean

    Dim bRet As Boolean
    
    bRet = False
    
    If m_Init = True Then

        If Invoke(m_pIMediaPosition, put_CurrentPosition, dPos) = S_OK Then

            bRet = True

        End If
    End If

    SetPosition = bRet

End Function

Public Function GetStopPosition() As Double

    Dim dRet As Double
    Dim dStopPos As Double

    If m_Init = True Then

        If Invoke(m_pIMediaPosition, get_StopTime, VarPtr(dStopPos)) = S_OK Then

            dRet = dStopPos

        End If
    
    End If

    GetStopPosition = dRet

End Function

Public Function SetStopPosition(ByVal dPos As Double) As Boolean

    Dim bRet As Boolean

    bRet = False

    If m_Init = True Then
    
        If dPos < 0 Then dPos = 0
        If dPos > Me.GetDuration Then dPos = Me.GetDuration

        If Invoke(m_pIMediaPosition, put_StopTime, dPos) = S_OK Then

            bRet = True

        End If
    End If

    SetStopPosition = bRet

End Function

Public Function GetBalance() As Long

    Dim lRet As Long
    Dim lBalance As Long

    If m_Init = True Then

        If Invoke(m_pIBasicAudio, get_Balance, VarPtr(lBalance)) = S_OK Then

            lRet = lBalance

        End If

    End If

    GetBalance = lRet

End Function

Public Function SetBalance(Optional ByVal lBalance As Long = 0) As Boolean

    Dim bRet As Boolean

    bRet = False

    If lBalance > 10000& Then lBalance = 10000&
    If lBalance < -10000& Then lBalance = -10000&
    
    If m_Init = True Then

        If Invoke(m_pIBasicAudio, put_Balance, lBalance) = S_OK Then
        
            bRet = True

        End If

    End If

    SetBalance = bRet

End Function

Public Function GetVolume() As Long

    Dim lRet As Long
    Dim lVolume As Long
    
    If m_Init = True Then

        If Invoke(m_pIBasicAudio, get_Volume, VarPtr(lVolume)) = S_OK Then

            lRet = lVolume

        End If

    End If

    GetVolume = lRet

End Function

Public Function SetVolume(Optional ByVal lVolume As Long = 0) As Boolean

    Dim bRet As Boolean

    bRet = False

    If lVolume > 0& Then lVolume = 0&
    If lVolume < -10000& Then lVolume = -10000&

    If m_Init = True Then

        If Invoke(m_pIBasicAudio, put_Volume, lVolume) = S_OK Then

            bRet = True

        End If

    End If

    SetVolume = bRet

End Function

Private Sub Class_Initialize()

    Call Initialize
    
End Sub

Private Sub Class_Terminate()

    Call Reset

End Sub

Private Sub Initialize()

    m_Init = False
    m_Info = False
    m_Rendered = False

    If modInterface.CreateInterface(m_pIGraphBuilder, CLSID_FilterGraph, _
        IID_IGraphBuilder) = True Then

        If Invoke(m_pIGraphBuilder, QueryInterface, VarPtr(Str2Guid( _
            IID_IBasicAudio)), VarPtr(m_pIBasicAudio)) = S_OK Then

            If Invoke(m_pIGraphBuilder, QueryInterface, VarPtr(Str2Guid( _
                IID_IMediaControl)), VarPtr(m_pIMediaControl)) = S_OK Then

                If Invoke(m_pIGraphBuilder, QueryInterface, VarPtr(Str2Guid( _
                    IID_IMediaPosition)), VarPtr(m_pIMediaPosition)) = S_OK Then

                    If Invoke(m_pIGraphBuilder, QueryInterface, VarPtr(Str2Guid( _
                        IID_IMediaSeeking)), VarPtr(m_pIMediaSeeking)) = S_OK Then

                        m_Init = True

                    End If

                End If

            End If

        End If
        
    End If

    If m_Init = False Then
    
        MsgBox "GraphBuilder cant create.", vbOKOnly Or vbInformation, "GraphBuilder"
        
    End If

End Sub

Private Sub Reset()
    
    m_Init = False
    m_Rendered = False

    If m_pIMediaControl <> 0& Then
    
        Call Invoke(m_pIMediaControl, Stop_Play)
        
    End If

    If m_pIMediaPosition <> 0& Then Call modInterface.Release(m_pIMediaPosition)
    If m_pIMediaSeeking <> 0& Then Call modInterface.Release(m_pIMediaSeeking)
    If m_pIMediaControl <> 0& Then Call modInterface.Release(m_pIMediaControl)
    If m_pIMediaEventEx <> 0& Then Call modInterface.Release(m_pIMediaEventEx)
    If m_pIBasicAudio <> 0& Then Call modInterface.Release(m_pIBasicAudio)
    If m_pIGraphBuilder <> 0& Then Call modInterface.Release(m_pIGraphBuilder)

End Sub

Public Function GetCover() As StdPicture

    Set GetCover = m_tMP3Info.Cover

End Function

Public Function GetInterpret() As String

    GetInterpret = m_tMP3Info.Interpret

End Function

Public Function GetSongtitel() As String

    GetSongtitel = m_tMP3Info.Songtitel

End Function

Public Function GetAlbumArtist() As String

    GetAlbumArtist = m_tMP3Info.AlbumArtist

End Function

Public Function GetAlbumTitle() As String

    GetAlbumTitle = m_tMP3Info.AlbumTitle

End Function

Public Function GetTrackNumber() As String

    GetTrackNumber = m_tMP3Info.TrackNumber

End Function

Public Function GetGenre() As String

    GetGenre = m_tMP3Info.Genre

End Function

Public Function GetSampleRate() As String

    GetSampleRate = m_tMP3Info.SampleRate

End Function

Public Function GetEncodingBitrate() As String

    GetEncodingBitrate = m_tMP3Info.EncodingBitrate

End Function

Public Function GetSampleSize() As String

    GetSampleSize = m_tMP3Info.SampleSize

End Function

Public Function GetChannelCount() As String

    GetChannelCount = m_tMP3Info.ChannelCount

End Function

Public Function GetIsVariableBitRate() As String

    GetIsVariableBitRate = m_tMP3Info.IsVariableBitRate

End Function

Private Function GetMediaInfo(ByVal sFileName As String) As Boolean

    Dim bRet As Boolean
    Dim pIPropertyStore As Long

    bRet = False

    ' IPropertyStore erstellen
    If SHGetPropertyStoreFromParsingName(StrPtr(sFileName), 0&, GPS_HANDLERPROPERTIESONLY, _
        Str2Guid(IID_IPropertyStore), pIPropertyStore) = S_OK Then

        ' falls ein Bild vorhanden ist, dieses lschen
        If Not m_tMP3Info.Cover Is Nothing Then Set m_tMP3Info.Cover = Nothing
        
        With m_tMP3Info
            Set .Cover = GetMp3Cover(pIPropertyStore)
            .Interpret = GetMp3Info(pIPropertyStore, "System.Author")
            .Songtitel = GetMp3Info(pIPropertyStore, "System.Title")
            .AlbumArtist = GetMp3Info(pIPropertyStore, "System.Music.AlbumArtist")
            .AlbumTitle = GetMp3Info(pIPropertyStore, "System.Music.AlbumTitle")
            .TrackNumber = GetMp3Info(pIPropertyStore, "System.Music.TrackNumber")
            .Genre = GetMp3Info(pIPropertyStore, "System.Music.Genre")
            .Duration = Format$(TimeSerial(0, 0, Int(CCur(GetMp3Info(pIPropertyStore, "System.Media.Duration") / 10000000@))), "Hh:Nn:Ss")
            .SampleRate = CStr(CLng(GetMp3Info(pIPropertyStore, "System.Audio.SampleRate")) / 1000&) & " kHz"
            .EncodingBitrate = CStr(CLng(GetMp3Info(pIPropertyStore, "System.Audio.EncodingBitrate")) / 1000&) & " kBit/s"
            .SampleSize = GetMp3Info(pIPropertyStore, "System.Audio.SampleSize") & " Bit"
            .ChannelCount = GetMp3Info(pIPropertyStore, "System.Audio.ChannelCount")
            .IsVariableBitRate = CStr(CBool(GetMp3Info(pIPropertyStore, "System.Audio.IsVariableBitRate")))
        End With
        
' for more Infos use this CanonicalNames
'
'    System.Author
'    System.Comment
'    System.Copyright
'    System.DateAccessed
'    System.DateCreated
'    System.DateImported
'    System.DateModified
'    System.DocumentDateCreated
'    System.DocumentDateSaved
'    System.DRMIsProtected
'    System.Rating
        
'    System.Audio.ChannelCount
'    System.Audio.EncodingBitrate
'    System.Audio.Format
'    System.Audio.IsVariableBitRate
'    System.Audio.SampleRate
'    System.Audio.SampleSize
'    System.Audio.StreamNumber
        
'    System.Music.AlbumArtist
'    System.Music.AlbumID
'    System.Music.AlbumTitle
'    System.Music.Artist
'    System.Music.BeatsPerMinute
'    System.Music.Composer
'    System.Music.Conductor
'    System.Music.ContentGroupDescription
'    System.Music.DisplayArtist
'    System.Music.Genre
'    System.Music.InitialKey
'    System.Music.IsCompilation
'    System.Music.Mood
'    System.Music.PartOfSet
'    System.Music.TrackNumber

'    System.Media.AuthorUrl
'    System.Media.Duration
'    System.Media.EncodedBy
'    System.Media.Publisher
'    System.Media.SubTitle
'    System.Media.Year
        
        bRet = True

        ' IPropertyStore freigeben
        Call modInterface.Release(pIPropertyStore)

    End If

    GetMediaInfo = bRet

End Function

Private Function GetMp3Info(ByVal pPropStore As Long, ByVal sCanonical As String) _
    As String

    Dim sRet As String
    Dim vRet As Variant
    Dim lItem As Long
    Dim lCount As Long
    Dim tFILETIME As FILETIME
    Dim tSYSTEMTIME As SYSTEMTIME
    Dim tPROPERTYKEY As PROPERTYKEY
    Dim tPROPVARIANT As PROPVARIANT

    ' CanonicalName -> PROPERTYKEY
    If PSGetPropertyKeyFromName(StrPtr(sCanonical), tPROPERTYKEY) = S_OK Then

        ' PROPERTYKEY auslesen
        If Invoke(pPropStore, GetValue, VarPtr(tPROPERTYKEY), _
            VarPtr(tPROPVARIANT)) = S_OK Then

            ' PROPVARIANT Varianttype
            Select Case tPROPVARIANT.vt

            Case VARENUM.VT_EMPTY, VARENUM.VT_STREAM
                sRet = vbNullString

            Case VARENUM.VT_BOOL, VARENUM.VT_BSTR, _
                VARENUM.VT_LPSTR, VARENUM.VT_LPWSTR, _
                VARENUM.VT_INT, VARENUM.VT_UINT, _
                VARENUM.VT_I1, VARENUM.VT_UI1, _
                VARENUM.VT_I2, VARENUM.VT_UI2, _
                VARENUM.VT_I4, VARENUM.VT_UI4, _
                VARENUM.VT_I8, VARENUM.VT_UI8, _
                VARENUM.VT_R4, VARENUM.VT_R8, _
                VARENUM.VT_CLSID

                ' PROPVARIANT -> String konvertieren
                If PropVariantChangeType(VarPtr(vRet), VarPtr(tPROPVARIANT), _
                    0&, VT_BSTR) = S_OK Then

                    sRet = CStr(vRet)

                End If

            Case VARENUM.VT_FILETIME

                ' PROPVARIANT -> FILETIME konvertieren
                If PropVariantToFileTime(tPROPVARIANT, PSTF_LOCAL, _
                    tFILETIME) = S_OK Then

                    ' FILETIME -> SYSTEMTIME
                    If FileTimeToSystemTime(tFILETIME, tSYSTEMTIME) <> 0 Then

                        With tSYSTEMTIME

                            sRet = Format$(.wDay, "00") & "." & Format$(.wMonth, _
                                "00") & "." & Format$(.wYear, "0000") & " " & _
                                Format$(.wHour, "00") & ":" & Format$(.wMinute, _
                                "00") & ":" & Format$(.wSecond, "00")

                        End With

                    End If

                End If

            Case VARENUM.VT_VECTOR Or VARENUM.VT_LPWSTR

                ' PROPVARIANT -> StringArray konvertieren
                If PropVariantChangeType(VarPtr(vRet), VarPtr(tPROPVARIANT), 0&, _
                    VT_ARRAY Or VT_BSTR) = S_OK Then

                    lCount = UBound(vRet)

                    For lItem = 0 To lCount

                        If lItem > 0 Then

                            sRet = sRet & ";"

                        End If

                        sRet = sRet & CStr(vRet(lItem))

                    Next

                End If

            Case Else
                sRet = vbNullString

            End Select

        End If

    End If

    GetMp3Info = sRet

End Function

Private Function GetMp3Cover(ByVal pPropStore As Long) As StdPicture

    Dim lBitmap As Long
    Dim hBitmap As Long
    Dim lGdipToken As Long
    Dim pIStream As Long
    Dim tPictDesc As PICTDESC
    Dim tPROPERTYKEY As PROPERTYKEY
    Dim tPROPVARIANT As PROPVARIANT
    Dim tGdipStartupInput As GDIPlusStartupInput
    Dim tGdipStartupOutput As GdiplusStartupOutput

    ' System.ThumbnailStream -> PROPERTYKEY
    If PSGetPropertyKeyFromName(StrPtr("System.ThumbnailStream"), _
        tPROPERTYKEY) = S_OK Then

        ' PROPERTYKEY auslesen
        If Invoke(pPropStore, GetValue, VarPtr(tPROPERTYKEY), _
            VarPtr(tPROPVARIANT)) = S_OK Then

            ' ist ein Pointer auf ein IStream vorhanden
            If tPROPVARIANT.vData <> 0& Then

                pIStream = tPROPVARIANT.vData

                tGdipStartupInput.GdiPlusVersion = GdiPlusVersion

                ' GDI+ starten
                If GdiplusStartup(lGdipToken, tGdipStartupInput, _
                    tGdipStartupOutput) = OK Then

                    ' GDI+ Bitmap vom Stream erstellen
                    If GdipCreateBitmapFromStream(pIStream, lBitmap) = OK Then

                        ' GDI32 Handle vom GDI+ Bitmap abrufen
                        If GdipCreateHBITMAPFromBitmap(lBitmap, hBitmap, 0&) = OK Then

                            With tPictDesc
                                .cbSizeOfStruct = Len(tPictDesc)
                                .PicType = PictureTypeConstants.vbPicTypeBitmap
                                .hgdiObj = hBitmap
                                .hPalOrXYExt = 0&
                            End With

                            ' Bitmap vom Handle erstellen
                            If OleCreatePictureIndirect(tPictDesc, Str2Guid(IID_IPicture), _
                                API_FALSE, GetMp3Cover) <> S_OK Then

                                Set GetMp3Cover = Nothing

                            End If

                        End If

                        ' GDI+ Bitmap lschen
                        Call GdipDisposeImage(lBitmap)

                    End If

                    ' GDI+ beenden
                    Call GdiplusShutdown(lGdipToken)

                End If

                ' IStream freigeben
                Call modInterface.Release(pIStream)

            End If

        End If

    End If

End Function

' ----==== Helper Func ====----
'
' ruft die Funktion OleInvoke im Modul modInterface auf
Private Function Invoke(ByVal pInterface As Long, ByVal vtb As vtb_Interfaces, _
    ParamArray var()) As Variant
    
    If pInterface <> 0& Then
    
        Invoke = modInterface.OleInvoke(pInterface, vtb, var)
        
    End If
    
End Function

' String -> GUID
Private Function Str2Guid(ByVal str As String) As GUID

    Dim pstr As Long
    
    pstr = StrPtr(str)
    
    Call CLSIDFromString(pstr, Str2Guid)
    
End Function

